/***  Add lower bound pruning?  ***/


#include <stdio.h>
#include <stdlib.h>

//#include "state.h"

#define B_ 1
#define EM_ 2
#define I_ 4
#define S_ 8
#define TT_ 16
#define U1_ 32
#define U2_ 64
#define U3_ 128


#define MAXW 1000


#define NNN 650000


typedef struct _State2_ {
  char B,EM,I,S,TT,U,sz,col;
} State2;
typedef short row[MAXW];
typedef unsigned char row2[MAXW];
typedef int row3[MAXW];

void traceback(int lo, int hi, int inv, char context, char colcon, char szcon,int indent, State2 *list);
P traceback2(int lo, int hi, int inv, char context, char colcon, char szcon, State2 *list, P *);
void buildlist(P p);
int dp_pl(int lo, int hi, State2 *list);
P rebuild(int lo, int hi, int inv, char context, char colcon, char szcon);




State2 mainlist[NNN];
int nnmax=0;

row cost[MAXW],icost[MAXW];
row2 state2[MAXW],istate2[MAXW];
row3 how[MAXW],ihow[MAXW];

P originalnode[NNN];



#include "window.c"



short bonusfor[256];


//#include "parse.c"



void prState(State2 s)
{
  printf("(%d%d%d%d%d%d%c%c)",s.B,s.EM,s.I,s.S,s.TT,s.U,s.sz,s.col);
}





void buildlist(P p)
{
  if (!p) return;
//  printf("%p\n",p);
  if ((p->optimal & OPT_OPT) && p->txt) {
    //printf("found opt, [%s]  ",p->txt);



    mainlist[nnmax].B =(p->state & F_B) ?1:0;
    mainlist[nnmax].I =(p->state & F_I) ?1:0;
    mainlist[nnmax].TT=(p->state & F_TT)?1:0;
    mainlist[nnmax].S =(p->state & F_S) ?1:0;
    mainlist[nnmax].EM=(p->state & F_EM)?1:0;
    mainlist[nnmax].U =(p->state & F_U)>>8;
    mainlist[nnmax].col=p->state & F_COLOR;
    mainlist[nnmax].sz= p->state & F_SIZE;
    if (!mainlist[nnmax].col) mainlist[nnmax].col='Z';
    if (!mainlist[nnmax].sz) mainlist[nnmax].sz='Z';
    originalnode[nnmax]=p;
    nnmax++;
  } else {
    buildlist(p->chld);
  }
  buildlist(p->next);
}

void buildlist2(P p)
{
  State sttemp;

  if (!p) return;
//  printf("%p\n",p);
  if ((p->optimal & OPT_OPT) && p->txt) {
//    printf("found opt, [%x]  ",p);

    if(nnmax==NNN) { fprintf(stderr,"Too big."); exit(0); }
    statetrans(p->state,p->trans,&sttemp);


    mainlist[nnmax].B =(sttemp & F_B) ?1:0;
    mainlist[nnmax].I =(sttemp & F_I) ?1:0;
    mainlist[nnmax].TT=(sttemp & F_TT)?1:0;
    mainlist[nnmax].S =(sttemp & F_S) ?1:0;
    mainlist[nnmax].EM=(sttemp & F_EM)?1:0;
    mainlist[nnmax].U =(sttemp & F_U)>>8;
    mainlist[nnmax].col=sttemp & F_COLOR;
    mainlist[nnmax].sz= sttemp & F_SIZE;
    if (!mainlist[nnmax].col) mainlist[nnmax].col='Z';
    if (!mainlist[nnmax].sz) mainlist[nnmax].sz='Z';
    originalnode[nnmax]=p;
 //   prState(mainlist[nnmax]); puts("");
    nnmax++;
  } else {
    buildlist2(p->chld);
  }
  buildlist2(p->next);
}

P everything(P p)
{
  int i;
  P p2;

  nnmax=0;
//  p2=p->next;
//  p->next=0;
  buildlist2(p);
//  p->next=p2;

//  for(i=0;i<nnmax;i++) { printf("%3d %x ",i,originalnode[i]); prState(mainlist[i]); puts(""); }

  if (nnmax>SWS) {
      return p;
      p2=slidingwindow();
      if (!p2) return p;
      else return p2;
  }
/*
  if(ftime < clock())
  {
    return p;
  }
 */   

  if (dp_pl(0,nnmax-1,mainlist)<0) return p;
  return traceback2(0,nnmax-1,0,0,'Z','Z',mainlist,originalnode);
}





int basecost(State2 s){  return s.B*7+s.EM*9+s.I*7+s.S*7+s.TT*9+s.U*7+(s.sz=='Z'?0:7)+(s.col=='Z'?0:7);}
int ibasecost(State2 s){  return s.B*7+s.I*7+s.S*7+s.TT*9+s.U*7+(s.sz=='Z'?0:7)+(s.col=='Z'?0:7)         +(!s.S && !s.EM ? 9:0);}

int dp_pl(int lo, int hi, State2 *list)
{
  int bonus;
  int nozcol, nozsz;
  int lm,rm;
  short temp;
  int n;
  int i,j,k;
  State all;
  int lb1,lb2,lb;
  int optpenaltyrt;
  int optpenaltyleft;

  

  for(i=0;i<256;i++) {
    bonusfor[i]=0;
    if (i & B_) bonusfor[i]+=7;
    //if (i &EM_) bonusfor[i]+=9;
    if (i & I_) bonusfor[i]+=7;
    if (i & S_) bonusfor[i]+=7;
    if (i &TT_) bonusfor[i]+=9;
    if (i &U1_) bonusfor[i]+=7;
    if (i &U2_) bonusfor[i]+=7;
    if (i &U3_) bonusfor[i]+=7;
  }



 // printf("called dp_pl %d %d %d\n",lo,hi);


  //puts("");
  //for(i=lo;i<=hi;i++) prState(list[i]),puts("");

  for(i=lo;i<=hi;i++) {
    cost[i][i]=basecost(list[i]);
    state2[i][i]=0;
    if (list[i].B ) state2[i][i]|= B_;
//    if (list[i].EM) state2[i][i]|=EM_;
    if (list[i].I ) state2[i][i]|= I_;
    if (list[i].S ) state2[i][i]|= S_;
    if (list[i].TT) state2[i][i]|=TT_;
    if (list[i].U>=1) state2[i][i]|=U1_;
    if (list[i].U>=2) state2[i][i]|=U2_;
    if (list[i].U>=3) state2[i][i]|=U3_;

    icost[i][i]=ibasecost(list[i]);

    istate2[i][i]=state2[i][i];
    //if (!list[i].S) istate2[i][i]^=EM_;

  }



  for(j=lo;j<=hi;j++) {
//    printf("%d\n",j);
  if(ftime < clock())
  {
    return -1;
  }

    for(i=j-1;i>=lo;i--) {

      nozcol=1; nozsz=1;

      for(k=i;k<=j;k++) {
        if (list[k].col=='Z') nozcol=0;
        if (list[k].sz=='Z') nozsz=0;
      }
      bonus=0;
      if (nozcol && list[i].col==list[j].col) bonus+=7;
      if (nozsz  && list[i].sz ==list[j].sz ) bonus+=7;


      cost[i][j]=29999;
      icost[i][j]=29999;


      for(k=i;k<j;k++) {
        if (cost[i][j]>cost[i][k]+cost[k+1][j]-bonusfor[state2[i][k]&state2[k+1][j]]) {
            cost[i][j]=cost[i][k]+cost[k+1][j]-bonusfor[state2[i][k]&state2[k+1][j]];
            state2[i][j]=state2[i][k]&state2[k+1][j];
            how[i][j]=k;
        }
      }


      for(k=j-1;k>=i;k--) {
        if (icost[i][j]>icost[i][k]+icost[k+1][j]-bonusfor[istate2[i][k]&istate2[k+1][j]]) {
            icost[i][j]=icost[i][k]+icost[k+1][j]-bonusfor[istate2[i][k]&istate2[k+1][j]];
            istate2[i][j]=istate2[i][k]&istate2[k+1][j];
            ihow[i][j]=k;
        }
      }



      if (i<=j-2) {
        temp=cost[i][i]+cost[j][j]-bonusfor[state2[i][i]&state2[j][j]]+cost[i+1][j-1]+9;
        if (cost[i][j]>=temp) {
//          printf("%d %d : %d -> %d !!\n",i,j,cost[i][j],temp);
//          printf("%d %d %d %d %d\n",cost[i][i],cost[j][j],bonusfor[state2[i][i]&state2[j][j]],cost[i+1][j-1],9);
          cost[i][j]=temp;
          how[i][j]=-1;
          state2[i][j]=state2[i][i]&state2[j][j];
        }
      }

      if (i<=j-2) {
        temp=icost[i][i]+icost[j][j]-bonusfor[istate2[i][i]&istate2[j][j]]+cost[i+1][j-1]+9;
        if (icost[i][j]>=temp) {
//          printf("i%d %d : %d -> %d !!\n",i,j,icost[i][j],temp);
//          printf("%d %d %d %d %d\n",icost[i][i],icost[j][j],bonusfor[istate2[i][i]&istate2[j][j]],cost[i+1][j-1],9);
          icost[i][j]=temp;
          ihow[i][j]=-1;
          istate2[i][j]=istate2[i][i]&istate2[j][j];
        }
      }

      if (cost[i][j]>icost[i][j]+9) {
//        printf("%d %d:  use i\n",i,j);
        cost[i][j]=icost[i][j]+9;
        state2[i][j]=istate2[i][j];
        //state2[i][j]&=~EM_;
        how[i][j]=-2;
      }

      if (icost[i][j]>cost[i][j]+9) {
//        printf("i%d %d:  use n\n",i,j);
        icost[i][j]=cost[i][j]+9;
        istate2[i][j]=state2[i][j];
        //istate2[i][j]&=~EM_;
        ihow[i][j]=-2;
      }

      cost[i][j]-=bonus;
      icost[i][j]-=bonus;

    }
  }

/*  for(i=lo;i<=hi;i++) {
    for(j=lo;j<i;j++) printf("                  ");
    for(j=i;j<=hi;j++) printf("(%2x%2d%3d/%2x%2d%3d) ",state2[i][j],how[i][j],cost[i][j],istate2[i][j],ihow[i][j],icost[i][j]);
    puts("");
  }
*/
// printf("dp(%d,%d)=%d\n",lo,hi,cost[lo][hi]);

//  printf("final state = %x\n",state2[lo][hi]);

  i=cost[lo][hi];
  //free(cost);

  return i;
}








State build_state(char context, unsigned char colcon, unsigned char szcon)
{
  State ret;

  ret=HI;
  if (context & B_ ) ret |= F_B;
  if (context & I_ ) ret |= F_I;
  if (context & S_ ) ret |= F_S;
  if (context & TT_) ret |= F_TT;
  if (context & EM_) ret |= F_EM;
  if (context & U1_) ret += F_U1;
  if (context & U2_) ret += F_U1;
  if (context & U3_) ret += F_U1;

  if (colcon!='Z') ret|=colcon;
  if (szcon!='Z')  ret|=szcon;
  return ret;
}

P dupnode (P x)
{
  P ret;
  ret=newPT();
  ret->chld=x->chld;
  ret->next=0;
  ret->state=x->state;
  ret->trans=x->trans;
  ret->txt=x->txt;
  ret->optimal=x->optimal;
  return ret;
}

P traceback2(int lo, int hi, int inv, char context, char colcon, char szcon, State2 *list, P *node)
{
  int nozcol,nozsz,k;
  int flag=0;
  row2 *st2;
  row3 *hw;
  char colcon2=colcon,szcon2=szcon,context2=context;
  char trst=0,trcol='Z',trsz='Z';
  P ret,p1,p2,ptemp,p3,ret2;

  if (inv==0) { st2=state2; hw=how; }
  else {st2=istate2; hw=ihow; }

  //printf("{%d %d %d %x %d %d}\n",lo,hi,inv,context,colcon,szcon);

  if (lo==hi) {



    ret=newPT();
    ret->chld=dupnode(node[lo]);
    ret->next=0;
    ret->state=build_state(context,colcon,szcon);

    ret->trans=build_state(st2[lo][lo] & (~context),
                           (list[lo].col!='Z' && colcon!=list[lo].col)?list[lo].col:'Z',
                           (list[lo].sz !='Z' &&  szcon!=list[lo].sz )?list[lo].sz :'Z');
    if ((inv ^ list[lo].EM) && !list[lo].S) ret->trans |=F_EM;

    if(0){ printf("leaf %s   %x %x     %x %x\n",ret->chld->txt,ret->state,ret->trans,ret->chld->state,ret->chld->trans);

}
    return ret;
  }

  if (hw[lo][hi]>=0) {
    nozcol=1; nozsz=1;
    for(k=lo;k<=hi;k++) {
      if (list[k].col=='Z') nozcol=0;
      if (list[k].sz =='Z') nozsz =0;
    }
    if (nozcol && list[lo].col==list[hi].col && colcon!=list[lo].col) {
      trcol=list[lo].col;
      colcon2=list[lo].col;
    }
    if (nozsz  && list[lo].sz ==list[hi].sz && szcon!=list[lo].sz) {
      trsz=list[lo].sz;
      szcon2=list[lo].sz;
    }
    if (st2[lo][hi] & (~context)) {
      trst=st2[lo][hi] & (~context);
      context2|=st2[lo][hi];
    }

    k=hw[lo][hi];
    //printf("[%d %d]++[%d %d]: trcol=%c\n",lo,k,k+1,hi,trcol);


    p1=traceback2(lo ,k ,inv,context2,colcon2,szcon2,list,node);
    p2=traceback2(k+1,hi,inv,context2,colcon2,szcon2,list,node);

    for(ptemp=p1;ptemp->next;ptemp=ptemp->next);
    ptemp->next=p2;

    ret=newPT();
    ret->chld=p1;
    ret->next=0;
    ret->state=build_state(context,colcon,szcon);
    ret->trans=build_state(trst,trcol,trsz);

    return ret;

  } else if (hw[lo][hi]==-1) {
    nozcol=1; nozsz=1;
    for(k=lo;k<=hi;k++) {
      if (list[k].col=='Z') nozcol=0;
      if (list[k].sz =='Z') nozsz =0;
    }
    if (nozcol && list[lo].col==list[hi].col && colcon!=list[lo].col && list[lo].col!='Z') {
      trcol=(list[lo].col);
      colcon2=list[lo].col;
    }
    if (nozsz && list[lo].sz ==list[hi].sz  &&  szcon!=list[lo].sz  && list[lo].sz !='Z') {
      trsz=(list[lo].sz );
      szcon2=list[lo].sz;
    }
    if (st2[lo][hi] & (~context)) {
      trst=(st2[lo][hi] & (~context));
      context2|=st2[lo][hi];
    }

    p1=traceback2(lo,lo,    inv,context2,colcon2,szcon2,list,node);
    p2=traceback2(lo+1,hi-1,0,   0    ,colcon2,szcon2,list,node);
    p3=traceback2(hi,hi,    inv,context2,colcon2,szcon2,list,node);

    ret2=newPT();
    ret2->chld=p2;
    ret2->next=p3;
    ret2->state=build_state(context2,colcon2,szcon2);
    ret2->trans=build_state(0,'Z','Z');
    ret2->trans|=F_PL;

    for(ptemp=p1;ptemp->next;ptemp=ptemp->next);
    ptemp->next=ret2;

    ret=newPT();
    ret->chld=p1;
    ret->next=0;
    ret->state=build_state(context,colcon,szcon);
    ret->trans=build_state(trst,trcol,trsz);
    return ret;

  } else if (hw[lo][hi]==-2) {

    p1=traceback2(lo,hi,inv^1,context ^EM_,colcon,szcon,list,node);

    ret=newPT();
    ret->chld=p1;
    ret->next=0;
    ret->state=build_state(context,colcon,szcon);
    ret->trans=build_state(0,'Z','Z');
    ret->trans|=F_EM;

    return ret;

  }
  fprintf(stderr,"invalid how = %d.\n",how[lo][hi]); exit(0);
}












void ind(int x){  for(;x;x--) printf("  ");}
//void printnice(char *txt){  if (!txt) { printf("(Null!)\n"); return; }  printf("[");  for(;*txt;txt++) {    if (*txt=='\n') printf("\\n");    else if (*txt=='\r') printf("\\r");    else if (*txt=='\t') printf("\\t");    else printf("%c",*txt);  }  printf("]\n");  return;}
void printnice(char *txt) { printf("%s",txt); }
void writestates(char st) { if (st & B_) printf("<B>"); /*if (st & EM_) printf("<EM>");*/  if (st & I_) printf("<I>");  if (st & S_) printf("<S>");  if (st & TT_) printf("<TT>");  if (st & U1_) printf("<U>");  if (st & U2_) printf("<U> ");  if (st & U3_) printf("<U>"); }
void unwritestates(char st) { if (st & B_) printf("</B>"); /*if (st & EM_) printf("</EM>");*/  if (st & I_) printf("</I>");  if (st & S_) printf("</S>");  if (st & TT_) printf("</TT>");  if (st & U1_) printf("</U>");  if (st & U2_) printf("</U> ");  if (st & U3_) printf("</U>"); }
char colname[16] ="!RGBCMYKW";
char szname[16] ="!0123456789";
void writecol(char col) { printf("<%c>",colname[col]); }
void unwritecol(char col) { printf("</%c>",colname[col]); }
void writesz(char sz) { printf("<%c>",szname[sz]); }
void unwritesz(char sz) { printf("</%c>",szname[sz]); }

void traceback(int lo, int hi, int inv, char context, char colcon, char szcon, int indent, State2 *list)
{
  int nozcol,nozsz,k;
  int flag=0;

  row2 *st2;
  row3 *hw;

  char colcon2=colcon,szcon2=szcon,context2=context;

  if (inv==0) { st2=state2; hw=how; }
  else {st2=istate2; hw=ihow; }


  //printf("{%d %d %d %x %d %d}\n",lo,hi,inv,context,colcon,szcon);


  if (lo==hi) {
    //ind(indent);
    if (list[lo].col!='Z' && colcon!=list[lo].col) writecol(list[lo].col);
    if (list[lo].sz!='Z' &&  szcon!=list[lo].sz)   writesz(list[lo].sz);
    if (st2[lo][lo] & (~context)) writestates(st2[lo][lo] & (~context));
    if ((inv^list[lo].EM) && !list[lo].S) printf("<EM>");

    printnice(originalnode[lo]->txt);

    if ((inv^list[lo].EM) && !list[lo].S) printf("</EM>");
    if (st2[lo][lo] & (~context)) unwritestates(st2[lo][lo] & (~context));
    if (list[lo].sz!='Z' &&  szcon!=list[lo].sz)   unwritesz(list[lo].sz);
    if (list[lo].col!='Z' && colcon!=list[lo].col) unwritecol(list[lo].col);

    return;
  }

  if (hw[lo][hi]>=0) {
    nozcol=1; nozsz=1;
    for(k=lo;k<=hi;k++) {
      if (list[k].col=='Z') nozcol=0;
      if (list[k].sz =='Z') nozsz =0;
    }
    if (nozcol && list[lo].col==list[hi].col && colcon!=list[lo].col) {
      writecol(list[lo].col);
      colcon2=list[lo].col;
    }
    if (nozsz  && list[lo].sz ==list[hi].sz && szcon!=list[lo].sz) {
      writesz(list[lo].sz);
      szcon2=list[lo].sz;
    }
    if (st2[lo][hi] & (~context)) {
      writestates(st2[lo][hi] & (~context));
      context2|=st2[lo][hi];
    }

    k=hw[lo][hi];

    traceback(lo ,k ,inv,context2,colcon2,szcon2,indent+1,list);
    traceback(k+1,hi,inv,context2,colcon2,szcon2,indent+1,list);


    if (st2[lo][hi] & (~context)) {
      unwritestates(st2[lo][hi] & (~context));
    }
    if (nozsz  && list[lo].sz ==list[hi].sz && szcon!=list[lo].sz) {
      unwritesz(list[lo].sz);
    }
    if (nozcol && list[lo].col==list[hi].col && colcon!=list[lo].col) {
      unwritecol(list[lo].col);
    }

    return;

  } else if (hw[lo][hi]==-1) {
    if (list[lo].col==list[hi].col && colcon!=list[lo].col && list[lo].col!='Z') {
      writecol(list[lo].col);
      colcon2=list[lo].col;
    }
    if (list[lo].sz ==list[hi].sz  &&  szcon!=list[lo].sz  && list[lo].sz !='Z') {
      writesz(list[lo].sz );
      szcon2=list[lo].sz;
    }
    if (st2[lo][hi] & (~context)) {
      writestates(st2[lo][hi] & (~context));
      context2|=st2[lo][hi];
    }

    traceback(lo,lo,inv,context2,colcon2,szcon2,indent,list);
    printf("<PL>");
    traceback(lo+1,hi-1,inv,0,colcon2,szcon2,indent+1,list);
    printf("</PL>");
    traceback(hi,hi,inv,context2,colcon2,szcon2,indent,list);

    if (st2[lo][hi] & (~context)) {
      unwritestates(st2[lo][hi] & (~context));
    }
    if (list[lo].sz ==list[hi].sz  &&  szcon!=list[lo].sz  && list[lo].sz !='Z') {
      unwritesz(list[lo].sz );
    }
    if (list[lo].col==list[hi].col && colcon!=list[lo].col && list[lo].col!='Z') {
      unwritecol(list[lo].col);
    }

    return;

  } else if (hw[lo][hi]==-2) {

    ind(indent); printf("<EM>");
    traceback(lo,hi,inv^1,context^EM_,colcon,szcon,indent+1,list);
    ind(indent); printf("</EM>");
    return;

  }

}





