#define COST_PL    9
#define COST_B     7
#define COST_I     7
#define COST_EM    9
#define COST_S     7
#define COST_TT    9
#define COST_U     7
#define COST_SIZE  7
#define COST_COLOR 7
#define HI      0xFFFF0000
#define LO      0x0000FFFF
// default colour or no change is 0000
#define COLR       0x00001
#define COLG       0x00002
#define COLB       0x00003
#define COLC       0x00004
#define COLM       0x00005
#define COLY       0x00006
#define COLK       0x00007
#define COLW       0x00008
#define F_COLOR    0x0000F
// the bits for size are the size+1 times F_SIZE1. 0 is no change, default
#define F_SIZE     0x000F0
#define F_SIZE1    0x00010
#define F_U        0x00300
#define F_U1       0x00100
#define F_TT       0x00400
#define F_S        0x00800
#define F_EM       0x01000
#define F_I        0x02000
#define F_B        0x04000
#define F_PL       0x08000
#define NOP        0x08000
#define F_BOOL     (F_B|F_I|F_EM|F_S|F_TT)
#define PLNEED     (F_B|F_I|F_S|F_TT)
#define PLOFF      (F_B|F_I|F_EM|F_S|F_TT|F_U)
#define SIZE(x)    (((x)+1)*F_SIZE1)
#define SPC_MASK   (F_SIZE|F_U|F_TT)
#define OPT_OPT    0x00000001
#define OPT_WS     0x00000002
typedef int bits;

typedef bits State;

typedef struct _ParseTree {
   struct _ParseTree *chld,*next;
   State state,trans;
   bits optimal;
   int leaves;
   char *txt;
} ParseTree, *P;

int spacestatediff(State s0,State s1,State *d);
int statediff(State s0,State s1,State *d);
void statetrans(State s0,State t,State *s1);
void transtrans(State s0,State t,State *s1);
int commonfac_incomplete(State t0,State t1,State *com,State *t0b,State *t1b);
State tag2trans(char tag);
int trans_out1(State t,char *buf);
int trans_out2(State t,char *buf);
